/*-
 * ~~~~~~licensing~~~~~~
 * base-extensions-support
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.extensions.shell;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.Option;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.support.table.ShellTable;

import ru.entaxy.esb.platform.runtime.base.extensions.api.EntaxyExtension;

@Service
@Command(scope = "entaxy", name = "extension-list")
public class ExtensionsList extends EntaxyExtensionServiceSupport {

	@Option(name = "-r", multiValued = false)
	boolean showResources;
	
	@Override
	public Object execute() throws Exception {
		ShellTable shellTable = new ShellTable();
		
		shellTable.column("Target");
		shellTable.column("Bundle");
		
		if (showResources) {
			shellTable.column("Resource");
			shellTable.column("Resource URL");
		}
		
		List<EntaxyExtension> list = extensionService.getExtensions();
		for (EntaxyExtension ext: list)
			if (!showResources)
				shellTable.addRow().addContent(ext.getTargetExtendableId(), ext.getBundleId());
			else {
				List<String> resources = new ArrayList<>(ext.getResources().keySet());
				Collections.sort(resources);
				for (String resource: resources) {
					shellTable.addRow().addContent(
							ext.getTargetExtendableId(), 
							ext.getBundleId(),
							resource,
							ext.getResources().get(resource).toString());
				}
			}
		
		shellTable.print(System.out);
		
		return null;
	}

}
